# $Id: inspector.tcl,v 1.7 2000/10/15 17:19:20 artur Exp $
# Von Artur Trzewik Modifiezierte (fr Tix) 
# Klassen und Object Betrachter
# Quelle (orginale wafe mofe Distribution Datei: Inspector.xotcl)
Class Inspector -parameter {graphShellObject}
Inspector instproc init args {
  [self] instvar ignoreClasses
  array set ignoreClasses {
    ::Inspector 1 ::InspectorShell 1 
    ::NodeShell 1 ::Class 1}
  [self] next
  [self] draw
}
Inspector instproc draw {} {
    [self] instvar graphShellObject 
    if {[$graphShellObject set subobjects]} {
	[self] drawObj
	return
    }
    $graphShellObject clearGraph
    #addTimeOut 100 [list [self] report ::Object]
    [self] report ::Object
    $graphShellObject show
}
Inspector instproc drawObj {} {
  [self] instvar graphShellObject
  $graphShellObject clearGraph
  [self] reportObj
  $graphShellObject show
}
Inspector instproc report {c} {
  [self] instvar graphShellObject ignoreClasses

  #puts stderr "subclass of $c = <[$c info subclass]>"
  foreach subclass [lsort [$c info subclass]] {
      if {[info exists ignoreClasses($subclass)]} continue
      # {[concat [$subclass info subclass] [$subclass info instances]] != ""} 
      $graphShellObject insertArc $c $subclass
  }
  foreach subclass [lsort [$c info subclass]] {
    if {[info exists ignoreClasses($subclass)]} continue
    # {[concat [$subclass info subclass] [$subclass info instances]] != ""} 
    if {1} {
      [self] report $subclass
    }
  }
  foreach instance [lsort [$c info instances]] {
    $graphShellObject insertInstanceArc $c $instance
  }
}
Inspector instproc reportObj {} {
  [self] instvar graphShellObject ignoreClasses
  foreach class [lsort [::Class info instances]] {
      if {[info exists ignoreClasses($class)]} continue
      foreach instance [$class info instances] {
	  if {[$instance info parent]=="::"} {
	      $graphShellObject insertSubObject "" [namespace tail $instance]
	      [self] reportSubObject $instance
	  }
      }
  }
}
Inspector instproc reportSubObject {obj} {
    [self] instvar graphShellObject
    foreach subobj [$obj info children] {
	$graphShellObject insertSubObject $obj [namespace tail $subobj]
	[self] reportSubObject $subobj
    }
}

Class InspectorShell
InspectorShell instproc init {} {
    [self] instvar S
    set S [toplevel .inspectorShell -width 400 -height 400]
    frame $S.bframe
    checkbutton $S.bframe.instances -text instances -variable [self]::instances
    checkbutton $S.bframe.subobjects -text subobjects -variable [self]::subobjects
    checkbutton $S.bframe.instprocs -text instprocs -variable [self]::instproc
    checkbutton $S.bframe.procs -text procs -variable [self]::procs
#    checkbutton $S.bframe.variables -text variables
    button $S.bframe.drawGraph -command [list [self]::inspector draw] \
	-text "Class Graph"
    #button $S.bframe.drawGraphObj -command "set instaces 1; [self]::inspector drawObj" \
	-text "Object Graph"
    tixTree $S.mtree -command [list [self] mselect] -options {
	hlist.separator "."
	hlist.width 35
	hlist.height 25
    }
    pack $S.bframe.instances $S.bframe.subobjects $S.bframe.instprocs \
	$S.bframe.procs $S.bframe.drawGraph -side top -anchor n

    pack $S.bframe $S.mtree -side right -expand yes -fill both
    Inspector [self]::inspector -graphShellObject [self]
}

InspectorShell instproc clearGraph {} {
  [self] instvar S nodes arcs
  $S.mtree subwidget hlist delete all
  foreach table {nodes arcs} {
    if {[info exists $table]} {unset $table}
  }
}
InspectorShell instproc show {} {
    [self] instvar S
    $S.mtree autosetmode  
    #manageChild $S*g
    #sV $S*g reLayout 1
    #popup $S none
}
# Name ist tixHList Element name
InspectorShell instproc classNode {cl name} {
  #puts stderr "creating ClassNode $cl $color"
  [self] instvar S instproc
  if {$instproc} {
      foreach m [lsort [$cl info instprocs]] { 
	  $S.mtree subwidget hlist add $name.$m -itemtype imagetext \
	      -text $m -image [tix getimage textfile]
      }
  }
  [self] objectNodeInfo $cl $name
#   set RC [XmRowColumn rc $S*g managed \
# 	      spacing 0 marginHeight 0 background gainsboro ]
#   #showRes $RC Dim
#   XmPushButtonGadget $cl $RC background $color \
#       activateCallback [list [self] classCb %w] \
#       recomputeSize 1 \
#       fontList -adobe-helvetica-bold-r-*-*-11-*-*-*-*-*-*-*
#   #showRes $cl Dim
#   if {[gV $S*framerc*instprocs set]} {
#     foreach m [lsort [$cl info instprocs]] {
#       XmPushButtonGadget $m $RC \
# 	  background gainsboro \
# 	  activateCallback [list [self] instprocCb $cl $m] \
# 	  recomputeSize 1 \
# 	  fontList -adobe-helvetica-medium-r-*-*-10-*-*-*-*-*-*-* \
# 	  marginWidth 0 marginBottom 0 marginHeight 0 highlightThickness 0
#     }
#   }
#   [self] objectNodeInfo $cl $RC
#   return $RC
}
# InspectorShell instproc objectNode {o} {
#     return objectNode
#     [self] instvar S 
    
#     set RC [XmRowColumn rc $S*g managed \
# 	      spacing 0 marginHeight 0 background gainsboro ]
#     XmPushButtonGadget $o $RC background firebrick \
# 	activateCallback [list [self] objectCb %w] \
# 	recomputeSize 1 \
#       fontList -adobe-helvetica-bold-r-*-*-11-*-*-*-*-*-*-*
#     [self] objectNodeInfo $o $RC
#     return $RC
# }

InspectorShell instproc objectNodeInfo {o name} {
    [self] instvar S procs
    if {$procs} {
	foreach x [lsort [$o info procs]] {
	    $S.mtree subwidget hlist add $name.$x -itemtype imagetext \
		-text $x -image [tix getimage srcfile]
	}
     }

#   if {[gV $S*framerc*procs set]} {
#     foreach x [lsort [$o info procs]] {
#       XmPushButtonGadget $x $RC \
# 	  background gray60 \
# 	  activateCallback [list [self] procCb $o $x] \
# 	  recomputeSize 1 \
# 	  fontList -adobe-helvetica-medium-r-*-*-10-*-*-*-*-*-*-* \
# 	  marginWidth 0 marginBottom 0 marginHeight 0 highlightThickness 0
#     }
#   }
#   if {[gV $S*framerc*variables set]} {
#     foreach x [lsort [$o info vars]] {
# 	XmPushButtonGadget $x $RC \
# 	  background white \
# 	  activateCallback [list [self] varCb $o $x] \
# 	  recomputeSize 1 \
# 	  fontList -adobe-helvetica-medium-r-*-*-10-*-*-*-*-*-*-* \
# 	  marginWidth 0 marginBottom 0 marginHeight 0 highlightThickness 0
#     }
#   }
}
# nodes ist ein Array 
# nodes(class) = tixHList name
InspectorShell instproc insertArc {from to} {
    #showCall
    [self] instvar S nodes
#     foreach node [list $from $to] {
# 	if {![info exists nodes($node)]} {
# 	    set nodes($node) [[self] classNode $node pink]
# 	}
#     }
    #puts "from $from $to"
    if {![info exists nodes($from)]} {
	# Dieses Teil wird nur beim Wurzel Aufgerufen
	$S.mtree subwidget hlist add $from -itemtype imagetext \
	    -text $from -image [tix getimage folder]
	set nodes($from) $from 
    }
    if {![info exists nodes($to)]} {
	set name "[set nodes($from)].$to"
	$S.mtree subwidget hlist add $name -itemtype imagetext \
	    -text $to -image [tix getimage folder]
	set nodes($to) $name
	[self] classNode $to $name 
    } else {
	# Merhfachvererbung
    }
}

InspectorShell instproc insertInstanceArc {from to} {
    # $from is the class, $to is the instance
    #showCall
    [self] instvar S nodes instances
    if {!$instances} return
    #   if {[info exists nodes($from)]} {
    #     #sV $nodes($from)*$from background yellow
    #   } else {
    #     set nodes($from) [[self] classNode $from yellow]
    #   }
    if {$from==""} {
	# Ein Wurzelelement
	$S.mtree subwidget hlist add $to -itemtype imagetext \
	    -text $to -image [tix getimage file]
	set nodes($to) $to 
	[self] objectNodeInfo $to $to 
	return
    }
    if {![info exists nodes($to)]} {
	set name "[set nodes($from)].$to"
	$S.mtree subwidget hlist add $name -itemtype imagetext \
	    -text $to -image [tix getimage file] 
	set nodes($to) $name
	[self] objectNodeInfo $to $name 
    }
}
InspectorShell instproc insertSubObject {parent to} {
    [self] instvar S
    set text "$to ([${parent}::$to info class])"
    if {$parent!=""} {
	regsub -all :: $parent . parent
	set name [string range $parent.$to 1 end]
    } else {
	set name $to
    }
    $S.mtree subwidget hlist add $name -itemtype imagetext \
	-text $text -image [tix getimage file]
}


InspectorShell instproc varCb {obj var} {
  [self] instvar S
  set msg ""
  set fullVarName ${obj}::$var
  if {[$obj array exists $var]} {
    foreach k [lsort [$obj array names $var]] {
      append msg "   $obj->${var}($k) = '[$obj set ${var}($k)]'" \n
    }
  } elsif {[info exists $fullVarName]} {
    append msg "   $obj->$var = '[$obj set $var]'" \n
  } else {
    append msg "   $obj->$var = UNKNOWN" \n
  }
  NodeShell ns -parent $S -text $msg -title "Variable $var of $obj"
  #ns$obj$var show
}

InspectorShell instproc instprocCb {cl m} {
  [self] instvar S
  set title "Instproc $m of $cl"
  NodeShell ns -parent $S -text [[self] instprocContent $cl $m] -title $title
}

InspectorShell instproc objectCb {o} {
  [self] instvar S
  set title "Contents of object $o (class [$o info class]):"
  NodeShell ns -parent $S -text [[self] objContent $o] -title $title
}
InspectorShell instproc procCb {o m} {
  [self] instvar S
  set title "Proc $m of $o"
  NodeShell ns -parent $S -text [[self] procContent $o $m] -title $title
}

InspectorShell instproc classCb {cl} { 
    [self] instvar S
    set msg ""
    append msg "parent Class [$cl info superclass]\n"
    foreach method [$cl info instprocs] {
        append msg [[self] instprocContent $cl $method]
    }
    append msg [[self] objContent $cl]
    NodeShell ns -parent $S -text $msg -title "Class $cl"
}


InspectorShell instproc instprocContent {o method} {
  return "$o instproc $method {[$o info instargs $method]} {\
      [$o info instbody $method]}\n\n"
}
InspectorShell instproc procContent {o method} {
    return "[namespace tail $o] proc $method {[$o info args $method]} {\
      [$o info body $method]}\n\n"
}
InspectorShell instproc objContent {o} {
  set msg ""
    set objname [namespace tail $o]
  foreach method [$o info procs] {
    append msg [[self] procContent $o $method]
  }
  append msg "#------------------------------- Variables ----\n"
  foreach a [lsort [$o info vars]] {
    set value ""
    set var ${o}::$a
    if {[array exists $var]} {
      foreach i [array names $var] {
	lappend value $i [set ${var}($i)]
      }
      append msg "$objname array set $a "
    } elseif {[info exists $var]} {
      append msg "$objname set $a "
      set value [set $var]
    } else {
      append msg "# $objname set $a "
      set value UNKNOWN
    }
    if {[string length $value]>1024} {
      set value [string range $value 0 1024]...
    }
    append msg [list $value] \n
  }
  return $msg
}
InspectorShell instproc mselect {selection} {
    [self] instvar S subobjects
    set image [$S.mtree subwidget hlist entrycget $selection -image]
    set name [lindex [split $selection .] end]
    if {$image==[tix getimage file]} then {
	if {$subobjects} {
	    [self] objectCb [join [split $selection .] ::]
	} else {
	    [self] objectCb $name
	}
    } elseif {$image==[tix getimage folder]} {
	[self] classCb $name
    } elseif {$image==[tix getimage textfile]} {
	set path [split $selection .]
	[self] instprocCb [lindex $path [expr [llength $path] -2]] $name
    } elseif {$image==[tix getimage srcfile]} {
	set path [split $selection .]
	[self] procCb [lindex $path [expr [llength $path] -2]] $name
    }
}

Class NodeShell -parameter {parent text title}
NodeShell instproc init args {
  [self] instvar parent text title
  [self] next
#   set D [XmMessageDialog inspectorShellMessage $parent unmanaged \
# 	     -dialogTitle $title \
# 	     -okCallback "destroyWidget %W"  \
# 	     -cancelCallback "destroyWidget %W" ]
#   unmanageChild $D*Message
#   XmScrolledText t $D \
#       -value $text \
#       -rows 20 -columns 40 \
#       -editMode MULTI_LINE_EDIT
#   manageChild $D
    if {[winfo exists $parent.info]} {

    } else { 
	toplevel $parent.info -class Dialog
	tixScrolledText $parent.info.text
	pack $parent.info.text -expand yes -fill both
    }
    $parent.info.text subwidget text delete 1.0 end
    $parent.info.text subwidget text insert 1.0 $text
}

InspectorShell inspectorShell
