#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: preferences.tcl,v 1.5 2000/10/15 17:19:20 artur Exp $
#
# Information:
# Modul
# setzt das lan globale Varible mit Sprachspzifischen Zeichenketten
# die aus *.lan Dateien ausgelesen werden
# Behandelt auch die Programm Optionnen in Datein ~/.xdobry

proc setlanguage language {
    global lan progdir
    set lanfile [open [file join $progdir ${language}.lan] r]
    while {[gets $lanfile Zeile] >= 0} {
	if {[string trim $Zeile]==""} continue
	set lankey [lindex $Zeile 0]
	if {$lankey=="begin"} {
	    lappend key [lindex $Zeile 1]
	    continue
	}
	if {$lankey=="end"} {
	    set key [lrange $key 0 [expr [llength $key]-2]]
	    continue
	}
	#puts $Zeile
	set lan([join [concat $key $lankey] .]) [lindex $Zeile 1]
    }
}
proc checklanguage {ext} {
    global option progdir
    if {$option(language)=="dummy"} {
	# buid checklanguage window
	set lanl {{type OComboBox} {name language} {label Language} }
	# Finde alle erreichbare *_.lan Dateien 
	# z.B englisch_fs.lan german_fs.lan
	set lan_files [glob [file join $progdir *_$ext.lan]]
	
	foreach lfile $lan_files {
	    regexp (.+)_$ext.lan [file tail $lfile] _ lan
	    lappend lans $lan
	}
	keylset lanl valuelist $lans
	set checkl {{type OCheckButton} {name forever} {label {use for next sesions}}}
	    
	OInputDialog landialog [list $lanl $checkl] {{language german}}  -message {Choose the Language for the session} -type ok -returnChanges 0
	if {[set ret [landialog execute]]!=""} {
	    set option(language) [keylget ret language]
	    if {[keylget ret forever]} {
		savepref
	    }
	}
	landialog destroy
    }
    setlanguage "$option(language)_$ext"
    # !!! Vorsicht beim nderungen
    if {$option(language)!="german"} {
	global helpdir
	append helpdir _en
    }
}

proc defaultpref {{var option}} {
    global $var
    array set $var {
	language dummy
	htmlhelpviewer {netscape %s}
	netscape_remote 1
    }
}
proc loadpref {} {
    global option tcl_platform
    defaultpref
    if {$tcl_platform(platform)=="windows"} {
    	if {![catch {package require registry}]} {
	    set reg_path {HKEY_CURRENT_USER\Software\xdobry}
	    if {![catch {set values [registry values $reg_path]}]} {
         	foreach val $values {
		    set option($val) [registry get $reg_path $val]
		}
	}
      }
    } else {
    	if {[file exists [file join ~  .xdobry]]} {
	    set preffile [open [file join ~ .xdobry] r]
	    while {[gets $preffile Zeile] >= 0} {
		set option([lindex $Zeile 0]) [lindex $Zeile 1]
	    }
	}
    }
}
proc savepref {} {
    global option lan errorInfo tcl_platform
    if {$tcl_platform(platform)=="windows"} {
    	if {![catch {package require registry}]} {
      	set reg_path {HKEY_CURRENT_USER\Software\xdobry}
	      set indicator [array startsearch option]
    		while {[array anymore option $indicator]} {
				set elem [array nextelement option $indicator]
  				registry set $reg_path $elem $option($elem)
    		}
      }
    } else {
     set ret [catch { set preffile [open [file join ~ .xdobry] w] }]
    if {$ret != 0} {
	tk_messageBox -title Error -message "$lan(message.csprefmessage) $errorInfo"  -icon error -type ok
	return
    }
    set indicator [array startsearch option]
    while {[array anymore option $indicator]} {
	set elem [array nextelement option $indicator]
	puts $preffile "$elem [list $option($elem)]"
    }
    close $preffile
    }
}

